// Реализовать функцию, которая позволит оценить, успеет ли команда 
// разработчиков сдать проект до наступления дедлайна. 
// Технические требования:

// Функция на вход принимает три параметра:

// массив из чисел, который представляет скорость работы разных членов команды. 
// Количество элементов в массиве означает количество человек в команде. Каждый элемент 
// означает сколько стори поинтов (условная оценка сложности выполнения задачи) может
//  выполнить данный разработчик за 1 день.

// массив из чисел, который представляет собой беклог (список всех задач, которые 
// необходимо выполнить). Количество элементов в массиве означает количество задач в беклоге. 
// Каждое число в массиве означает количество стори поинтов, необходимых для выполнения данной задачи.

// дата дедлайна (объект типа Date).


// После выполнения, функция должна посчитать, успеет ли команда разработчиков 
// выполнить все задачи из беклога до наступления дедлайна (работа ведется начиная с сегодняшнего дня). 
// Если да, вывести на экран сообщение: Все задачи будут успешно выполнены за ? дней до наступления дедлайна!. 
// Подставить нужное число дней в текст. Если нет, вывести сообщение Команде разработчиков придется потратить 
// дополнительно ? часов после дедлайна, чтобы выполнить все задачи в беклоге

// Работа идет по 8 часов в день по будним дням

const teamArr = [8, 10, 3, 1, 4]; //, условный балл успеваемости каждого члена команды за один день
const backlog = [19, 13, 2, 7, 9]; //: условный балл для завершения

const deadline = new Date('2020-09-04');

function checkTeamProgress(team, backlog, date) {

    let teamArrSum = team.reduce((sum, current) => {
        return sum + current;
    }, 0);

    let backlogSum = backlog.reduce((sum, current) => {
        return sum + current;
    }, 0);

    let currentDate = new Date();

    let workDays = 0;
    while (currentDate < date) {
        if (currentDate.getDay() !== 0 && currentDate.getDay() !== 6) {
            workDays++;
        }
        currentDate.setDate(currentDate.getDate() + 1);
    }
    let completeDays = (backlogSum / teamArrSum);
    completeDays = Math.round(completeDays);

    if (completeDays < workDays) {
        return (`Все задачи будут успешно выполнены за ${workDays - completeDays} дней до наступления дедлайна!`);
    } else if (workDays === completeDays) {
        return (`Задачи будут выполнены в срок`);
    } else {
        return (`Команде разаработчиков придется потратить дополнительно ${(completeDays - workDays) * 8} часов после дедлайна, чтоб выполнить все задачи в беклоге`);
    }
}
console.log(checkTeamProgress(teamArr, backlog, deadline));




